# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import wizard
import netsvc
import pooler
import base64
import json
from osv import fields, osv
import csv

init_form = """<?xml version="1.0"?>
<form string="Export JSON File for Website" height="400">
    <field name="edition" width="600"/>
</form>
"""
init_fields = {
    'edition': {'string':u'Edition', 'type':'integer','required':True},
}

form = """<?xml version="1.0"?>
<form string="JSON File for Popup Website">
    <field name="exposants.json"/>
</form>
"""

fields = {
    'exposants.json':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

def get_phone(phone_num):
    result = ''
    if phone_num:
        result = phone_num
    return result
def _correct_vat(cr, uid, vat):
    corrected_vat = vat.strip().replace(' ','').replace('/','').replace('-','').replace('.','').upper()
    if len(corrected_vat ) >= 8:
        if corrected_vat[0:2] == 'BE':
            if len(corrected_vat) == 12:
                pass
            elif len(corrected_vat) == 11:
                corrected_vat = 'BE0'+corrected_vat[2:]
            else:
                corrected_vat = ''
        else:
            if corrected_vat[0:2].isdigit():
                if len(corrected_vat) == 10:
                    corrected_vat = 'BE' + corrected_vat
                elif corrected_vat == 9:
                    corrected_vat = 'BE0' + corrected_vat
                else:
                    corrected_vat = ''
            else:
                # suppose stranger VAT number : let it untouched
                corrected_vat = corrected_vat
        if len(corrected_vat) == 12 and corrected_vat[0:2] == 'BE':
            # belgian complete vat number => check digit
            try:
                fullnum = int(corrected_vat[2:])
            except:
                corrected_vat = ''
                fullnum = 0
            if fullnum:
                if int(corrected_vat[-2:]) != (97 - (int(corrected_vat[2:10]) % 97)):
                    corrected_vat = ''
    else:
        corrected_vat = ''
    return corrected_vat
    
class export_stands4site(wizard.interface):

    def _create_json_file(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)
        stand_obj = pool_obj.get('cci.popup.stand')
        stand_ids = stand_obj.search(cr,uid,[('edition','=',data['form']['edition'])])
        if stand_ids:
            stands = stand_obj.browse(cr,uid,stand_ids,{'lang':'fr_FR'})
            dStands = {}
            for stand in stands:
                if stand.partner_id:
                    record = {}
                    record['name'] = stand.name or stand.partner_id.name
                    address = False
                    for addr in stand.partner_id.address:
                        if addr.type == 'default':
                            address = addr
                    if address:
                        record['street'] = address.street or ''
                        record['street2'] = address.street2 or ''
                        record['zip_city'] = address.zip_id.name+' '+address.zip_id.city
                        record['phone'] = get_phone(address.phone)
                        record['website'] = stand.partner_id.website or ''
                        record['activ_desc'] = stand.partner_id.activity_description or ''
                        record['erp_id'] = stand.id
                        record['webapp_id'] = 0
                if not dStands.has_key(record['name']):
                    dStands[record['name']] = record
            json_string = json.dumps(dStands.values(),indent=4)
            data['form']['exposants.json']=base64.encodestring(json_string)
        return data['form']

    states = {
        'init' : {
               'actions' : [],
               'result': {'type': 'form', 'arch': init_form, 'fields': init_fields, 'state':[('end','Cancel'),('export','Export')]}
            },
        'export' : {
               'actions' : [_create_json_file],
               'result': {'type': 'form', 'arch': form, 'fields': fields, 'state':[('end','Close')]}
            },

    }

export_stands4site("export_stands4site")

